#include <GL/glut.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <ctime>
#include <cmath>
#include "meshdraw.h"
#include "gl_screenshot.h"
#include "diff.h"
#include "materials.cpp"

// openglȉ̃R[obN֐
void display_();
void reshape_(int w, int h);
void idle_();
void keyboard_(unsigned char key, int x, int y);



MeshDraw::MeshDraw()
{
	frame = 0;
	pos_cam = 3.0;
	theta_x = 0;
	theta_y = 0;
	theta_light = 0;
}

MeshDraw::~MeshDraw()
{
}

bool MeshDraw::init(int argc, char* argv[], Solver* s)
{
	sol = s;
	normal.resize((sol->NX+1)*(sol->NY+1));

	glutInit(&argc, argv);
	glutInitWindowPosition(100 , 50);
	glutInitWindowSize(400 , 400);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("a");
	glutDisplayFunc(display_);
	glutReshapeFunc(reshape_);
	glutKeyboardFunc(keyboard_);
	//glutIdleFunc(idle_);

	return true;
}

void MeshDraw::mainloop()
{
	glutMainLoop();
}

void MeshDraw::display()
{
	glClearColor(0.65, 0.68, 0.92, 0.0);

	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	
	glEnable(GL_FOG);
	GLfloat fogcolor[] = {1.0, 1.0, 1.0, 1.0};
	glFogfv(GL_FOG_COLOR, fogcolor);
	glFogi(GL_FOG_MODE, GL_EXP2);
	glFogf(GL_FOG_DENSITY, 0.1);
// 	glFogf(GL_FOG_START, 8);
// 	glFogf(GL_FOG_END, 10);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();
	gluLookAt(pos_cam, pos_cam, pos_cam, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0);

	// Cg̐ݒ
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	//glEnable(GL_LIGHT1);
	glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);  // ʂ
	LightStruct ls_light0 = {{2.0*cos(theta_light*sol->PI/180.0), 2.0*sin(theta_light*sol->PI/180.0), 2.8, 1.0},
		{0.0, 0.0, 0.0, 1.0},
		{1.0, 1.0, 1.0, 1.0},
		{1.0, 1.0, 1.0, 1.0}
	};
	//LightStruct ls_light1 = {{2.5, 0.3, 3.0, 1.0},
		//{0.0, 0.0, 0.0, 1.0},
		//{1.0, 1.0, 1.0, 1.0},
		//{1.0, 1.0, 1.0, 1.0}
	//};
	set_light(GL_LIGHT0, ls_light0);
	//set_light(GL_LIGHT1, ls_light1);

	/*
	set_material(ms_silver);
	int N = 100;
	double h = (3.0-(-3.0))/N;
	for (int i=0; i<N; i++) {
		for (int j=0; j<N; j++) {
			glBegin(GL_POLYGON);
			glNormal3d(1, 0, 0);
			glVertex3d(-3, -3+j*h, 3-i*h);
			glVertex3d(-3, -3+j*h, 3-(i+1)*h);
			glVertex3d(-3, -3+(j+1)*h, 3-(i+1)*h);
			glVertex3d(-3, -3+(j+1)*h, 3-i*h);
			glEnd();
			glBegin(GL_POLYGON);
			glNormal3d(0, 1, 0);
			glVertex3d(-3+j*h,     -3, 3-i*h);
			glVertex3d(-3+j*h,     -3, 3-(i+1)*h);
			glVertex3d(-3+(j+1)*h, -3, 3-(i+1)*h);
			glVertex3d(-3+(j+1)*h, -3, 3-i*h);
			glEnd();
			glBegin(GL_POLYGON);
			glNormal3d(0, 0, 1);
			glVertex3d(-3+j*h,     3-i*h,     -3);
			glVertex3d(-3+j*h,     3-(i+1)*h, -3);
			glVertex3d(-3+(j+1)*h, 3-(i+1)*h, -3);
			glVertex3d(-3+(j+1)*h, 3-i*h,     -3);
			glEnd();
		}
	}
	*/

	// ]
	glTranslated(0.5, 0.5, 0);
	glRotated((double)theta_x, 0, 0, 1);
	glRotated((double)theta_y, 0, 1, 0);
	glTranslated(-0.5, -0.5, 0);

	render();

	glutSwapBuffers();
	//keep_fps();
}

void MeshDraw::render()
{
	ms_turquoise.shininess = 100.0;
	set_material(ms_turquoise);
	set_normal_average();

	for (int i=0; i<2*sol->NX*sol->NY; i++) {
		glBegin(GL_TRIANGLES);

		// _A@
		for (int j=0; j<3; j++) {
			glNormal3d(normal[sol->elem(i)->node[j]->index].nx,
					   normal[sol->elem(i)->node[j]->index].ny,
					   normal[sol->elem(i)->node[j]->index].nz);
			glVertex3d(sol->elem(i)->node[j]->x,
					   sol->elem(i)->node[j]->y,
					   sol->elem(i)->node[j]->v[frame]);
		}

		glEnd();
	}
}

void MeshDraw::reshape(int w, int h)
{
	glViewport(0, 0, w, h);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(40.0, (double)w / (double)h, 1.0, 100.0);
	//glOrtho(-0.5, 0.5, -0.5, 0.5, -0.5, 0.5);

	glMatrixMode(GL_MODELVIEW);
}

void MeshDraw::keyboard(unsigned char key, int x, int y)
{
	if (key == 0x1B) {
		std::cerr << "aborted." << std::endl;
		exit(0);
	}
	else if (key == 's') {
		static int fileno = 0;
		std::stringstream ss;
		ss << "out_";
		ss << std::setw(3) << std::setfill('0') << std::right << fileno++;
		ss << ".bmp";

		screenshot(ss.str().c_str());
		std::cerr << "screenshot => " << ss.str() << std::endl;

		// ibjt[i߂
		frame = (frame + 1) % (sol->NT+1);
		display();
	}
	else if (key == 'f') {
		theta_x = (theta_x + 2) % 360;
		display();
	}
	else if (key == 'g'){
		theta_y = (theta_y + 2) % 360;
		display();
	}
	else if (key == 'F') {
		theta_x -= 2;
		if (theta_x < 0) {
			theta_x = 360 - 2;
		}
		display();
	}
	else if (key == 'G'){
		theta_y -= 2;
		if (theta_y < 0) {
			theta_y = 360 - 2;
		}
		display();
	}
	else if (key == ' ') {
		frame = (frame + 1) % (sol->NT+1);
		display();
	}
	else if (key == 'c') {
		pos_cam -= 0.1;
		display();
	}
	else if (key == 'C') {
		pos_cam += 0.1;
		display();
	}
	else if (key == 'l') {
		theta_light = (theta_light + 2) % 360;
		display();
	}
}

void MeshDraw::idle()
{
	glutPostRedisplay();
}

void MeshDraw::keep_fps()
{
	const int FPS = 50;
	static clock_t time_fps = 0;

	while (clock() - time_fps < CLOCKS_PER_SEC/1000 * 1000/FPS) {
		;
	}
	time_fps = clock();
}

bool MeshDraw::screenshot(const char* filename)
{
	gl_screenshot gs;
	return gs.screenshot(filename, 32);
}

void MeshDraw::spectrum_color(double x, int &r, int &g, int &b)
{
	double red=0, green=0, blue=0;

	if ((0 <= x) && (x <= 20)) {
		green = 255.0 * x/20.0;
		blue  = 255.0;
	}
	else if ((20 < x) && (x <= 35)) {
		green = 255.0;
		blue  = 255.0 * (15.0-(x-20.0))/15.0;
	}
	else if ((35 < x) && (x <= 50)) {
		red   = 255.0 * (x-30.0)/15.0;
		green = 255.0;
	}
	else if ((50 < x) && (x <= 80)) {
		red   = 255.0;
		green = 255.0 * (30.0-(x-50.0))/30.0;
	}
	else if ((80 < x) && (x <= 100)) {
		red   = 255.0;
		green = 255.0 * (x-80.0)/20.0;
		blue  = 255.0 * (x-80.0)/20.0;
	}

	r = (int)red;
	g = (int)green;
	b = (int)blue;
}

void MeshDraw::set_material(MaterialStruct& ms)
{
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ms.ambient);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, ms.diffuse);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, ms.specular);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, ms.shininess);
}

void MeshDraw::set_light(int light, LightStruct &ls)
{
	glLightfv(light, GL_POSITION, ls.position);
	glLightfv(light, GL_AMBIENT, ls.ambient);
	glLightfv(light, GL_DIFFUSE, ls.diffuse);
	glLightfv(light, GL_SPECULAR, ls.specular);
}

void MeshDraw::get_normal(int i, double &nx, double &ny, double &nz)
{
	const double &xi = sol->elem(i)->node[0]->x;
	const double &xj = sol->elem(i)->node[1]->x;
	const double &xk = sol->elem(i)->node[2]->x;
	const double &yi = sol->elem(i)->node[0]->y;
	const double &yj = sol->elem(i)->node[1]->y;
	const double &yk = sol->elem(i)->node[2]->y;
	const double &zi = sol->elem(i)->node[0]->v[frame];
	const double &zj = sol->elem(i)->node[1]->v[frame];
	const double &zk = sol->elem(i)->node[2]->v[frame];

	nx = (yj-yi)*(zk-zi)-(zj-zi)*(yk-yi);
	ny = (zj-zi)*(xk-xi)-(xj-xi)*(zk-zi);
	nz = (xj-xi)*(yk-yi)-(yj-yi)*(xk-xi);
	const double n  = sqrt(nx*nx + ny*ny + nz*nz);
	nx /= n;
	ny /= n;
	nz /= n;
}

void MeshDraw::set_normal_average()
{
	for (int i=0; i<2*sol->NX*sol->NY; i++) {
		double nx, ny, nz;
		get_normal(i, nx, ny, nz);  // Op`(i)̖@xNg
		for (int j=0; j<3; j++) {   // e_ɑ킹
			normal[sol->elem(i)->node[j]->index].nx += nx;
			normal[sol->elem(i)->node[j]->index].ny += ny;
			normal[sol->elem(i)->node[j]->index].nz += nz;
		}
	}

	// Pʒ֐K
	for (int i=0; i<(sol->NX+1)*(sol->NY+1); i++) {
		double n = sqrt(normal[i].nx*normal[i].nx
						+ normal[i].ny*normal[i].ny + normal[i].nz*normal[i].nz);
		normal[i].nx /= n;
		normal[i].ny /= n;
		normal[i].nz /= n;
	}
}
