#ifndef MESHDRAW_H_INCLUDED
#define MESHDRAW_H_INCLUDED

#include <vector>
using namespace std;


class Solver;

struct NormalStruct {
	double nx;
	double ny;
	double nz;
};

struct MaterialStruct {
	GLfloat ambient[4];
	GLfloat diffuse[4];
	GLfloat specular[4];
	GLfloat shininess;
};
struct LightStruct {
	GLfloat position[4];
	GLfloat ambient[4];
	GLfloat diffuse[4];
	GLfloat specular[4];
};

// `NX
class MeshDraw {
	Solver* sol;
	int frame;    //  t=frame
	int theta_x;  // ]p
	int theta_y;  // 
	double pos_cam;   // J̈ʒu
	int theta_light;   // Cg̈ʒu
	vector<NormalStruct> normal;  // ̕ςƂ@

public:
	MeshDraw();
	~MeshDraw();

	bool init(int argc, char* argv[], Solver* s);
	void mainloop();

	void display();
	void reshape(int w, int h);
	void keyboard(unsigned char key, int x, int y);
	void idle();

private:
	void render();
	bool screenshot(const char* filename);
	void spectrum_color(double x, int &r, int &g, int &b);
	void set_material(MaterialStruct &ms);
	void set_light(int light, LightStruct &ls);

	void get_normal(int i, double &nx, double &ny, double &nz);
	void set_normal_average();

	void keep_fps();
};



#endif
